variables:
  TAG_LATEST: $CI_REGISTRY_IMAGE/$CI_COMMIT_REF_NAME:latest
  TAG_COMMIT: $CI_REGISTRY_IMAGE/$CI_COMMIT_REF_NAME:$CI_COMMIT_SHORT_SHA

stages:
  - e2e

cypress-e2e:
  image: cypress/base:16
  stage: e2e
  script:
    - npm install
    - npm run start &
    - $(npm bin)/cypress run

#   - setup
#   - test
#   - publish
#   - deploy

# install:
#   image: node:16.16-bullseye
#   stage: setup
#   script: 
#     - echo "Latest $TAG_LATEST"
#     - echo "Commit $TAG_COMMIT"
#     - npm ci

# unit test:
#   image: node:16.16-bullseye
#   stage: test
#   before_script:  
#     - apt-get update
#     - wget https://dl.google.com/linux/direct/google-chrome-stable_current_amd64.deb
#     - apt install -y ./google-chrome*.deb;
#     - export CHROME_BIN=/usr/bin/google-chrome
#   script:
#     - npm ci
#     - npm run test -- --no-watch --browsers=ChromeHeadlessCI

# variables:
#   TAG_LATEST: $CI_REGISTRY_IMAGE/$CI_COMMIT_REF_NAME:latest
#   TAG_COMMIT: $CI_REGISTRY_IMAGE/$CI_COMMIT_REF_NAME:$CI_COMMIT_SHORT_SHA
#   CI_BUILD_TOKEN: GkiXWZXdnZdaebRgJ6R3
#   DOCKER_HOST: tcp://docker:2375
#   DOCKER_TLS_CERTDIR: ""
#   DOCKER_DRIVER: overlay2

# publish:
#   image: docker:latest
#   stage: publish
#   services:
#     - docker:dind
#   script:
#     - docker build -t $TAG_COMMIT -t $TAG_LATEST .
#     - docker login -u ci_token -p $CI_BUILD_TOKEN $CI_REGISTRY
#     - docker push $TAG_COMMIT
#     - docker push $TAG_LATEST

# deploy:
#   image: alpine:latest
#   stage: deploy
#   tags:
#     - deployment
#   script:
#     - chmod og= $ID_RSA
#     - apk update && apk add openssh-client
#     - ssh -i $ID_RSA -o StrictHostKeyChecking=no $SERVER_USER@$SERVER_IP "docker login -u ci_token -p $CI_BUILD_TOKEN $CI_REGISTRY"
#     - ssh -i $ID_RSA -o StrictHostKeyChecking=no $SERVER_USER@$SERVER_IP "docker pull $TAG_COMMIT"
#     - ssh -i $ID_RSA -o StrictHostKeyChecking=no $SERVER_USER@$SERVER_IP "docker container rm -f my-app || true"
#     - ssh -i $ID_RSA -o StrictHostKeyChecking=no $SERVER_USER@$SERVER_IP "docker run -d -p 5001:80 --name my-app $TAG_COMMIT"